from __future__ import annotations
import sys
from importlib.machinery import ModuleSpec, PathFinder
from importlib.machinery import all_suffixes as module_suffixes
from importlib.util import spec_from_file_location
from itertools import chain
from pathlib import Path

MAPPING: dict[str, str] = {'dist': 'D:\\Technologies\\python\\ksrpdfparser\\dist', 'examples': 'D:\\Technologies\\python\\ksrpdfparser\\examples', 'ksrpdfparser': 'D:\\Technologies\\python\\ksrpdfparser\\ksrpdfparser', 'tests': 'D:\\Technologies\\python\\ksrpdfparser\\tests', 'venv': 'D:\\Technologies\\python\\ksrpdfparser\\venv'}
NAMESPACES: dict[str, list[str]] = {'dist': ['D:\\Technologies\\python\\ksrpdfparser\\dist'], 'examples': ['D:\\Technologies\\python\\ksrpdfparser\\examples'], 'tests': ['D:\\Technologies\\python\\ksrpdfparser\\tests'], 'venv': ['D:\\Technologies\\python\\ksrpdfparser\\venv'], 'venv.Include': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Include'], 'venv.Lib': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib'], 'venv.Scripts': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Scripts'], 'venv.Lib.site-packages': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages'], 'venv.Lib.site-packages.jaraco': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\jaraco'], 'venv.Lib.site-packages.cryptography.hazmat.bindings._rust': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\cryptography\\hazmat\\bindings\\_rust'], 'venv.Lib.site-packages.cryptography.hazmat.bindings._rust.openssl': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\cryptography\\hazmat\\bindings\\_rust\\openssl'], 'venv.Lib.site-packages.docutils.parsers.rst.include': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\docutils\\parsers\\rst\\include'], 'venv.Lib.site-packages.docutils.writers.s5_html.themes': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\docutils\\writers\\s5_html\\themes'], 'venv.Lib.site-packages.docutils.writers.s5_html.themes.big-black': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\docutils\\writers\\s5_html\\themes\\big-black'], 'venv.Lib.site-packages.docutils.writers.s5_html.themes.big-white': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\docutils\\writers\\s5_html\\themes\\big-white'], 'venv.Lib.site-packages.docutils.writers.s5_html.themes.default': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\docutils\\writers\\s5_html\\themes\\default'], 'venv.Lib.site-packages.docutils.writers.s5_html.themes.medium-black': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\docutils\\writers\\s5_html\\themes\\medium-black'], 'venv.Lib.site-packages.docutils.writers.s5_html.themes.medium-white': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\docutils\\writers\\s5_html\\themes\\medium-white'], 'venv.Lib.site-packages.docutils.writers.s5_html.themes.small-black': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\docutils\\writers\\s5_html\\themes\\small-black'], 'venv.Lib.site-packages.docutils.writers.s5_html.themes.small-white': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\docutils\\writers\\s5_html\\themes\\small-white'], 'venv.Lib.site-packages.id._internal': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\id\\_internal'], 'venv.Lib.site-packages.numpy.doc': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\doc'], 'venv.Lib.site-packages.numpy.f2py.src': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\src'], 'venv.Lib.site-packages.numpy.f2py.tests.src': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src'], 'venv.Lib.site-packages.numpy.f2py.tests.src.abstract_interface': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\abstract_interface'], 'venv.Lib.site-packages.numpy.f2py.tests.src.array_from_pyobj': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\array_from_pyobj'], 'venv.Lib.site-packages.numpy.f2py.tests.src.assumed_shape': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\assumed_shape'], 'venv.Lib.site-packages.numpy.f2py.tests.src.block_docstring': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\block_docstring'], 'venv.Lib.site-packages.numpy.f2py.tests.src.callback': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\callback'], 'venv.Lib.site-packages.numpy.f2py.tests.src.cli': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\cli'], 'venv.Lib.site-packages.numpy.f2py.tests.src.common': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\common'], 'venv.Lib.site-packages.numpy.f2py.tests.src.crackfortran': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\crackfortran'], 'venv.Lib.site-packages.numpy.f2py.tests.src.f2cmap': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\f2cmap'], 'venv.Lib.site-packages.numpy.f2py.tests.src.isocintrin': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\isocintrin'], 'venv.Lib.site-packages.numpy.f2py.tests.src.kind': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\kind'], 'venv.Lib.site-packages.numpy.f2py.tests.src.mixed': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\mixed'], 'venv.Lib.site-packages.numpy.f2py.tests.src.modules': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\modules'], 'venv.Lib.site-packages.numpy.f2py.tests.src.negative_bounds': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\negative_bounds'], 'venv.Lib.site-packages.numpy.f2py.tests.src.parameter': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\parameter'], 'venv.Lib.site-packages.numpy.f2py.tests.src.quoted_character': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\quoted_character'], 'venv.Lib.site-packages.numpy.f2py.tests.src.regression': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\regression'], 'venv.Lib.site-packages.numpy.f2py.tests.src.return_character': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\return_character'], 'venv.Lib.site-packages.numpy.f2py.tests.src.return_complex': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\return_complex'], 'venv.Lib.site-packages.numpy.f2py.tests.src.return_integer': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\return_integer'], 'venv.Lib.site-packages.numpy.f2py.tests.src.return_logical': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\return_logical'], 'venv.Lib.site-packages.numpy.f2py.tests.src.return_real': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\return_real'], 'venv.Lib.site-packages.numpy.f2py.tests.src.routines': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\routines'], 'venv.Lib.site-packages.numpy.f2py.tests.src.size': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\size'], 'venv.Lib.site-packages.numpy.f2py.tests.src.string': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\string'], 'venv.Lib.site-packages.numpy.f2py.tests.src.value_attrspec': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\value_attrspec'], 'venv.Lib.site-packages.numpy.f2py.tests.src.modules.gh25337': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\modules\\gh25337'], 'venv.Lib.site-packages.numpy.f2py.tests.src.modules.gh26920': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\f2py\\tests\\src\\modules\\gh26920'], 'venv.Lib.site-packages.numpy.lib.tests.data': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\lib\\tests\\data'], 'venv.Lib.site-packages.numpy.random.lib': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\random\\lib'], 'venv.Lib.site-packages.numpy.random._examples': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\random\\_examples'], 'venv.Lib.site-packages.numpy.random._examples.cffi': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\random\\_examples\\cffi'], 'venv.Lib.site-packages.numpy.random._examples.cython': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\random\\_examples\\cython'], 'venv.Lib.site-packages.numpy.random._examples.numba': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\random\\_examples\\numba'], 'venv.Lib.site-packages.numpy.typing.tests.data': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\typing\\tests\\data'], 'venv.Lib.site-packages.numpy.typing.tests.data.fail': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\typing\\tests\\data\\fail'], 'venv.Lib.site-packages.numpy.typing.tests.data.misc': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\typing\\tests\\data\\misc'], 'venv.Lib.site-packages.numpy.typing.tests.data.pass': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\typing\\tests\\data\\pass'], 'venv.Lib.site-packages.numpy.typing.tests.data.reveal': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\typing\\tests\\data\\reveal'], 'venv.Lib.site-packages.numpy._core.include': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\_core\\include'], 'venv.Lib.site-packages.numpy._core.lib': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\_core\\lib'], 'venv.Lib.site-packages.numpy._core.tests': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\_core\\tests'], 'venv.Lib.site-packages.numpy._core.include.numpy': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\_core\\include\\numpy'], 'venv.Lib.site-packages.numpy._core.include.numpy.random': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\_core\\include\\numpy\\random'], 'venv.Lib.site-packages.numpy._core.lib.npy-pkg-config': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\_core\\lib\\npy-pkg-config'], 'venv.Lib.site-packages.numpy._core.lib.pkgconfig': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\_core\\lib\\pkgconfig'], 'venv.Lib.site-packages.numpy._core.tests.data': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\_core\\tests\\data'], 'venv.Lib.site-packages.numpy._core.tests.examples': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\_core\\tests\\examples'], 'venv.Lib.site-packages.numpy._core.tests.examples.cython': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\_core\\tests\\examples\\cython'], 'venv.Lib.site-packages.numpy._core.tests.examples.limited_api': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\numpy\\_core\\tests\\examples\\limited_api'], 'venv.Lib.site-packages.pandas.io.formats.templates': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pandas\\io\\formats\\templates'], 'venv.Lib.site-packages.pdfminer.cmap': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pdfminer\\cmap'], 'venv.Lib.site-packages.pkg_resources.tests.data': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pkg_resources\\tests\\data'], 'venv.Lib.site-packages.pkg_resources.tests.data.my-test-package-source': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pkg_resources\\tests\\data\\my-test-package-source'], 'venv.Lib.site-packages.pkg_resources.tests.data.my-test-package-zip': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pkg_resources\\tests\\data\\my-test-package-zip'], 'venv.Lib.site-packages.pkg_resources.tests.data.my-test-package_unpacked-egg': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pkg_resources\\tests\\data\\my-test-package_unpacked-egg'], 'venv.Lib.site-packages.pkg_resources.tests.data.my-test-package_zipped-egg': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pkg_resources\\tests\\data\\my-test-package_zipped-egg'], 'venv.Lib.site-packages.pymupdf.mupdf-devel': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pymupdf\\mupdf-devel'], 'venv.Lib.site-packages.pymupdf.mupdf-devel.include': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pymupdf\\mupdf-devel\\include'], 'venv.Lib.site-packages.pymupdf.mupdf-devel.lib': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pymupdf\\mupdf-devel\\lib'], 'venv.Lib.site-packages.pymupdf.mupdf-devel.include.mupdf': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pymupdf\\mupdf-devel\\include\\mupdf'], 'venv.Lib.site-packages.pymupdf.mupdf-devel.include.mupdf.fitz': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pymupdf\\mupdf-devel\\include\\mupdf\\fitz'], 'venv.Lib.site-packages.pymupdf.mupdf-devel.include.mupdf.helpers': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pymupdf\\mupdf-devel\\include\\mupdf\\helpers'], 'venv.Lib.site-packages.pymupdf.mupdf-devel.include.mupdf.pdf': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pymupdf\\mupdf-devel\\include\\mupdf\\pdf'], 'venv.Lib.site-packages.pytz.zoneinfo': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pytz\\zoneinfo'], 'venv.Lib.site-packages.pytz.zoneinfo.Africa': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pytz\\zoneinfo\\Africa'], 'venv.Lib.site-packages.pytz.zoneinfo.America': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pytz\\zoneinfo\\America'], 'venv.Lib.site-packages.pytz.zoneinfo.Antarctica': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pytz\\zoneinfo\\Antarctica'], 'venv.Lib.site-packages.pytz.zoneinfo.Arctic': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pytz\\zoneinfo\\Arctic'], 'venv.Lib.site-packages.pytz.zoneinfo.Asia': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pytz\\zoneinfo\\Asia'], 'venv.Lib.site-packages.pytz.zoneinfo.Atlantic': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pytz\\zoneinfo\\Atlantic'], 'venv.Lib.site-packages.pytz.zoneinfo.Australia': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pytz\\zoneinfo\\Australia'], 'venv.Lib.site-packages.pytz.zoneinfo.Brazil': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pytz\\zoneinfo\\Brazil'], 'venv.Lib.site-packages.pytz.zoneinfo.Canada': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pytz\\zoneinfo\\Canada'], 'venv.Lib.site-packages.pytz.zoneinfo.Chile': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pytz\\zoneinfo\\Chile'], 'venv.Lib.site-packages.pytz.zoneinfo.Etc': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pytz\\zoneinfo\\Etc'], 'venv.Lib.site-packages.pytz.zoneinfo.Europe': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pytz\\zoneinfo\\Europe'], 'venv.Lib.site-packages.pytz.zoneinfo.Indian': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pytz\\zoneinfo\\Indian'], 'venv.Lib.site-packages.pytz.zoneinfo.Mexico': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pytz\\zoneinfo\\Mexico'], 'venv.Lib.site-packages.pytz.zoneinfo.Pacific': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pytz\\zoneinfo\\Pacific'], 'venv.Lib.site-packages.pytz.zoneinfo.US': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pytz\\zoneinfo\\US'], 'venv.Lib.site-packages.pytz.zoneinfo.America.Argentina': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pytz\\zoneinfo\\America\\Argentina'], 'venv.Lib.site-packages.pytz.zoneinfo.America.Indiana': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pytz\\zoneinfo\\America\\Indiana'], 'venv.Lib.site-packages.pytz.zoneinfo.America.Kentucky': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pytz\\zoneinfo\\America\\Kentucky'], 'venv.Lib.site-packages.pytz.zoneinfo.America.North_Dakota': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\pytz\\zoneinfo\\America\\North_Dakota'], 'venv.Lib.site-packages.setuptools._vendor': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\setuptools\\_vendor'], 'venv.Lib.site-packages.setuptools.tests.indexes': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\setuptools\\tests\\indexes'], 'venv.Lib.site-packages.setuptools.tests.indexes.test_links_priority': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\setuptools\\tests\\indexes\\test_links_priority'], 'venv.Lib.site-packages.setuptools.tests.indexes.test_links_priority.simple': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\setuptools\\tests\\indexes\\test_links_priority\\simple'], 'venv.Lib.site-packages.setuptools.tests.indexes.test_links_priority.simple.foobar': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\setuptools\\tests\\indexes\\test_links_priority\\simple\\foobar'], 'venv.Lib.site-packages.setuptools._distutils.compilers': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\setuptools\\_distutils\\compilers'], 'venv.Lib.site-packages.setuptools._distutils.compilers.C': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\setuptools\\_distutils\\compilers\\C'], 'venv.Lib.site-packages.setuptools._distutils.compilers.C.tests': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\setuptools\\_distutils\\compilers\\C\\tests'], 'venv.Lib.site-packages.setuptools._vendor.jaraco': ['D:\\Technologies\\python\\ksrpdfparser\\venv\\Lib\\site-packages\\setuptools\\_vendor\\jaraco']}
PATH_PLACEHOLDER = '__editable__.ksrpdfparser-0.1.1.finder' + ".__path_hook__"


class _EditableFinder:  # MetaPathFinder
    @classmethod
    def find_spec(cls, fullname: str, path=None, target=None) -> ModuleSpec | None:  # type: ignore
        # Top-level packages and modules (we know these exist in the FS)
        if fullname in MAPPING:
            pkg_path = MAPPING[fullname]
            return cls._find_spec(fullname, Path(pkg_path))

        # Handle immediate children modules (required for namespaces to work)
        # To avoid problems with case sensitivity in the file system we delegate
        # to the importlib.machinery implementation.
        parent, _, child = fullname.rpartition(".")
        if parent and parent in MAPPING:
            return PathFinder.find_spec(fullname, path=[MAPPING[parent]])

        # Other levels of nesting should be handled automatically by importlib
        # using the parent path.
        return None

    @classmethod
    def _find_spec(cls, fullname: str, candidate_path: Path) -> ModuleSpec | None:
        init = candidate_path / "__init__.py"
        candidates = (candidate_path.with_suffix(x) for x in module_suffixes())
        for candidate in chain([init], candidates):
            if candidate.exists():
                return spec_from_file_location(fullname, candidate)
        return None


class _EditableNamespaceFinder:  # PathEntryFinder
    @classmethod
    def _path_hook(cls, path) -> type[_EditableNamespaceFinder]:
        if path == PATH_PLACEHOLDER:
            return cls
        raise ImportError

    @classmethod
    def _paths(cls, fullname: str) -> list[str]:
        paths = NAMESPACES[fullname]
        if not paths and fullname in MAPPING:
            paths = [MAPPING[fullname]]
        # Always add placeholder, for 2 reasons:
        # 1. __path__ cannot be empty for the spec to be considered namespace.
        # 2. In the case of nested namespaces, we need to force
        #    import machinery to query _EditableNamespaceFinder again.
        return [*paths, PATH_PLACEHOLDER]

    @classmethod
    def find_spec(cls, fullname: str, target=None) -> ModuleSpec | None:  # type: ignore
        if fullname in NAMESPACES:
            spec = ModuleSpec(fullname, None, is_package=True)
            spec.submodule_search_locations = cls._paths(fullname)
            return spec
        return None

    @classmethod
    def find_module(cls, _fullname) -> None:
        return None


def install():
    if not any(finder == _EditableFinder for finder in sys.meta_path):
        sys.meta_path.append(_EditableFinder)

    if not NAMESPACES:
        return

    if not any(hook == _EditableNamespaceFinder._path_hook for hook in sys.path_hooks):
        # PathEntryFinder is needed to create NamespaceSpec without private APIS
        sys.path_hooks.append(_EditableNamespaceFinder._path_hook)
    if PATH_PLACEHOLDER not in sys.path:
        sys.path.append(PATH_PLACEHOLDER)  # Used just to trigger the path hook
